/*  Copyright (c) by Reinhard Nickels rnickels@web.de, November 2012
  This file is free software; you can redistribute it and/or modify
  it under the terms of either the GNU General Public License version 2
  or the GNU Lesser General Public License version 2.1, both as
  published by the Free Software Foundation.
*/

/* PulseMon_PLX_DAQ_AD_PLCDV_1.0
Release Notes: 
16.11.2012 V1.0 released
*/

#include <LiquidCrystal.h>
#define PULSEPIN 8

LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
unsigned long start, dauer, bpm, timeo;
unsigned long mittel[10];
unsigned long mittels;
int i=0, j;
int user;

void setup()
{
  lcd.begin(16, 2);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Heartbeat Counter!");
  lcd.setCursor(0,1);
  lcd.print("SW Ver 1.0");
  delay(500);
  lcd.clear();
  lcd.print(__DATE__);
  lcd.setCursor(0,1);
  lcd.print(__TIME__);
  delay(100);
  pinMode(PULSEPIN, INPUT);
  digitalWrite(PULSEPIN,HIGH);  // enable Pullup
  Serial.begin(9600); 
   Serial.println("USER1,LABEL,Bar Graph");   // ob PLX-DAQ läuft oder nicht, kann aber erst beim ersten Zugriff gesetzt werden
  Serial.flush();
  Serial.println("USER1,GET");
  timeo = millis();
  while (!Serial.available() and (millis()-timeo < 3000)) {}   // Timeout für Abfrage Timegraph oder Bar
  user = Serial.read();    // 49 = user  , 48 = !user, -1 = not connected to PLX-DAQ
  lcd.clear();
  if (user==-1) {
    lcd.print("No user setting");    // keine Verbindung zu PLX-DAQ
    Serial.println("TIMER, BPM, AVG(10)");
  }
  else  { 
    lcd.print("User setting=");
    lcd.print(user); }
  if (user==49)  {
    Serial.println("CELL,SET,$A4,BPM");
    Serial.println("CELL,SET,$A6,AVG10");
    Serial.println("CELL,SET,$A7,BPM");
  }
  else if (user==48) {
    Serial.println("LABEL, Timer, Time, AVG10, BPM");
  }
  else if (user==50) {           // Diag mode  "2"
  diag2();
  } 
  else if (user==51) {           // Diag mode  "3"
  diag3();
  } 
  else if (user==52) {           // Diag mode  "4"
  diag4();
  } 
  delay(500);
  while (digitalRead(PULSEPIN))  {}  // warte auf LOW
  delay(10);
  while (!digitalRead(PULSEPIN))  {}  // warte auf HIGH
  delay(10);  // warte einen Zyklus ab
}

void loop()
{
  while (digitalRead(PULSEPIN))  {}  // warte auf LOW
  lcd.clear();
  dauer = millis() - start;
  start = millis();
  lcd.setCursor(0,0);
  lcd.print("BPM ");
  bpm = 60000/(dauer);
  lcd.print(bpm);
  mittel[i] = bpm;
  for (j=0;j<10;j++) {
    mittels = mittels + mittel[j]; 
  }
  lcd.setCursor(0,1);
  lcd.print("AVG(10) ");
//  lcd.print(i);
//  lcd.print("  ");
  if (mittel[9]==0)  {   // warte bis 10 Werte
    lcd.print("NaN");
  }
  else  {
    lcd.print((mittels*10+51)/100);
  }
  i++;
  if (i==10) {
    i=0; }
  if (user==49)  {
    Serial.print("CELL,SET,$B6,");
    Serial.println((mittels*10+51)/100);
    Serial.print("CELL,SET,$B7,");
    Serial.println(bpm);
  }
  else if (user==48)  {
    Serial.print("DATA, TIMER, TIME, ");
    Serial.print((mittels*10+51)/100);
    Serial.print(",");
    Serial.println(bpm);
    }
  else  {
  //  Serial.print(millis());
  //  Serial.print(",");
    Serial.print(bpm);
    Serial.print(",");
    Serial.println((mittels*10+51)/100);
  }
  mittels = 0;
  while (!digitalRead(PULSEPIN))  {}  // warte auf HIGH
  delay(10);
}

void diag2()  {     // Diagnostik Mode
  lcd.clear();
  lcd.print("Diagnostik 2");
  lcd.setCursor(0,1);
  lcd.print("5 sec serial");
  int timer = millis();
  while (millis()-timer < 5000)  {
    lcd.setCursor(0,1);
    Serial.print(analogRead(0));
    Serial.print("  ");
    Serial.println(analogRead(1));
  }
}

void diag3()  {     // Diagnostik Mode
  lcd.clear();
  lcd.print("Diagnostik 3");
  lcd.setCursor(0,1);
  lcd.print("poweroff to stop");
  delay(2000);
  lcd.clear();
  int A0 = analogRead(0);
  int maxA0 = A0;
  int minA0 = A0;
  unsigned long timer = millis();
  lcd.setCursor(0,0);
  lcd.print("poweroff to stop");
  while (1)  {     // running endless
    lcd.setCursor(0,1);
    lcd.print("                ");
    lcd.setCursor(0,1);
    int A0 = analogRead(0);
    if (A0<minA0) {
      minA0 = A0; }
    if (A0>maxA0) {
      maxA0 = A0; }
    lcd.print(minA0);
    lcd.print(" ");
    lcd.print(maxA0);
    lcd.print(" ");
    lcd.print(analogRead(1));
    delay(250);
    if ((millis()-timer)>10000)  {
      timer = millis();
      minA0=(minA0+maxA0)>>1;
      maxA0=minA0;
    }
  }
}
  
void diag4()  {
  lcd.clear();
  lcd.print("Diagnosemode 4");
  lcd.setCursor(0,1);
  lcd.print("poweroff to stop");
  int sensorValue = 0;        // this program module is taken from lxaroscope package, Copyright (C) 2011,2012 Oskar Leuthold (http://sourceforge.net/projects/lxardoscope/)
  byte lb;
  byte hb;
  Serial.println("Diag Mode 4");
  Serial.println("Baudrate ab jetzt 115200 - Beenden durch Reset");
  Serial.begin(115200); 
  while (1)  {     // running endless
  // read A0:
  sensorValue = analogRead(A0);            
// shift sample by 3 bits, and select higher byte  
  hb=highByte(sensorValue<<3); 
// set 3 most significant bits and send out
  Serial.write(hb|224); 
// select lower byte and clear 3 most significant bits
  lb=(lowByte(sensorValue))&31;
// set bits 5 and 6 and send out
  Serial.write(lb|96);
// read A1
  sensorValue = analogRead(A1);            
// shift sample by 3 bits, and select higher byte 
  hb=highByte(sensorValue<<3); 
// set bits 5 and 6 and send out
  Serial.write(hb|96); 
// select lower byte and clear 3 most significant bits
  lb=(lowByte(sensorValue))&31;
// set bits 5 and 6 and send out
  Serial.write(lb|96);
  }
} 
